Subject: Re: [PATCH net-next] tcp: try to defer / return acked skbs to originating CPU

From: Jakub Kicinski <[email-masked]>
Date: Mon, 16 Feb 2026 10:11:08 -0800

On Mon, 16 Feb 2026 18:58:08 +0100 Eric Dumazet wrote:
> > > I think I totally missed your email :/
> > >
> > > What about not attempting defer for zero copy skbs ?
> > >
> > > It turns out existing patch e20dfbad8aab ("net: fix napi_consume_skb()
> > > with alien skbs") is already a problem for zcopy.  
> >
> > We definitely need either this or the timer patch I attached, for UDP.
> >
> > I put the TCP write side on a back burner because slab sheaves got
> > merged, I think skb defer free will still make a difference but IDK
> > how much. Maybe juice will no longer be worth the squeeze?  
> 
> It depends how many frags are attached to each skb.
> 
> page frags are not yet handled by SLUB sheaves :)

Ack, my recollection is that more of the cycles are spent in slab than
pcp handling, tho. I could be misremembering. But my thinking was that
if we both:
 - lose zc sends due to the unbounded completion time
 - lose the slab benefit due to sheaves
we are only left with fairly narrow case of page handling of small skbs.
My gut feeling was that however unclean the timer fix would be best
since it gives us zc back. But I don't have a way to experiment with
sheaves yet to get data. All of this is pure speculation.

Regardless the patch you shared earlier is probably best as a fix for
zero-copy UDP for now.